﻿'Bing Maps SDK for metro style appsのダウンロードおよびインストールは，Visual Studioの「ツール」メニューの「拡張機能と更新」から行えます
Imports Bing.Maps
Imports System.Net.Http
Imports Windows.UI
Imports Windows.UI.Xaml.Shapes
Imports Windows.Storage
Imports Windows.UI.Popups

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page
    Dim myResponse As String
    Dim zIndexNo As Integer = 0
    Dim zIndexNo2 As Integer = 0
    Dim myFile2 As New List(Of String)
    Dim myUri As Uri = New Uri("http://api.nmzu.jp/history.xml", UriKind.Absolute)
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("EarthQuakeData", CreationCollisionOption.OpenIfExists)
        Dim earthQuakeData = Await mySubFolder.GetFilesAsync
        If earthQuakeData.Count = 0 Then
            dataShowButton.IsEnabled = False
        Else
            dataSaveButton.IsEnabled = True
        End If
        DataShow()
    End Sub

    Private Async Sub DataShow()
        Try
            Dim myHttpClient As New HttpClient
            myResponse = Await myHttpClient.GetStringAsync(myUri)
            myMap.MapType = MapType.Road

            Dim detectionDate As String = String.Empty
            Dim myLocation As String = String.Empty
            Dim myLatitude As String = String.Empty
            Dim myLongitude As String = String.Empty
            Dim myMagnitude As String = String.Empty
            Dim myIntensity As String = String.Empty
            Dim nowYear As Integer = Date.Now.Year
            Dim nowMonth As Integer = Date.Now.Month
            Dim nowDay As Integer = Date.Now.Day
            Dim myDate As String = CStr(nowYear.ToString & "/" & nowMonth.ToString("00") & "/" & nowDay.ToString("00"))

            Dim xmldoc As XElement = XElement.Parse(myResponse)


            For Each result In From c In xmldoc.Descendants("entry") Select c

                zIndexNo += 1
                myLocation = result.Element("epicenter").Element("name").Value
                detectionDate = result.Element("detection_date").Value
                myLatitude = result.Element("epicenter").Element("coordinate").Element("latitude").Value
                myLongitude = result.Element("epicenter").Element("coordinate").Element("longitude").Value
                myMagnitude = result.Element("magnitude").Value
                myIntensity = result.Element("intensity_no").Value
                myMap.Center = New Location(CDbl(myLatitude), CDbl(myLongitude))
                Dim myEllipse As New Ellipse
                myEllipse.Width = 20
                myEllipse.Height = 20
                myEllipse.Stroke = New SolidColorBrush(Colors.Blue)

                Dim myStackPanel As New StackPanel
                myStackPanel.SetValue(Canvas.ZIndexProperty, zIndexNo)
                'myStackPanel.Margin = New Thickness(10)
                myStackPanel.Background = New SolidColorBrush(Colors.Gainsboro)
                myStackPanel.Visibility = Xaml.Visibility.Collapsed
                Dim myTextBlock As New TextBlock
                myTextBlock.Padding = New Thickness(5)
                myTextBlock.Text = "発生日時=" & detectionDate & vbCrLf & "震源地=" & myLocation & vbCrLf & "マグニチュード=" & myMagnitude & vbCrLf & "震度=" & myIntensity
                myTextBlock.Foreground = New SolidColorBrush(Colors.Navy)
                myTextBlock.FontSize = 20
                myStackPanel.Children.Add(myTextBlock)

                Dim _myLocation = New Location(CDbl(myLatitude), CDbl(myLongitude))
                MapLayer.SetPosition(myStackPanel, _myLocation)
                myMap.Children.Add(myStackPanel)
                myMap.SetView(_myLocation, 6)

                Dim _myDate As DateTime = Date.Now

                Dim _Year = _myDate.Year
                Dim _Month = _myDate.AddDays(0).Month.ToString("00")
                Dim _Day = _myDate.AddDays(-1).Day.ToString("00")

                Dim _myDate2 As String = _Year & "/" & _Month & "/" & _Day
                If detectionDate.Contains(_myDate2) = True Then
                    myEllipse.Fill = New SolidColorBrush(Colors.Orange)
                ElseIf detectionDate.Contains(myDate) = True Then
                    myEllipse.Fill = New SolidColorBrush(Colors.Red)
                Else
                    myEllipse.Fill = New SolidColorBrush(Colors.Yellow)
                End If

                MapLayer.SetPosition(myEllipse, New Location(CDbl(myLatitude), CDbl(myLongitude)))
                myMap.Children.Add(myEllipse)

                AddHandler myEllipse.Tapped, Sub()
                                                 myStackPanel.Visibility = Xaml.Visibility.Visible
                                             End Sub

                AddHandler myStackPanel.Tapped, Sub()
                                                    myStackPanel.Visibility = Xaml.Visibility.Collapsed
                                                End Sub
            Next
        Catch
            DataShow()
        End Try

    End Sub

    Private Async Sub dataSaveButton_Click(sender As Object, e As RoutedEventArgs) Handles dataSaveButton.Click

        Dim myFile As String = DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".xml"
        Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("EarthQuakeData", CreationCollisionOption.OpenIfExists)
        Dim saveFile As StorageFile = Await mySubFolder.CreateFileAsync(myFile)
        Await FileIO.WriteTextAsync(saveFile, myResponse)
        Dim myMessage As New MessageDialog("保存しました")
        Await myMessage.ShowAsync
        dataShowButton.IsEnabled = True
    End Sub

    Private Async Sub dataShowButton_Click(sender As Object, e As RoutedEventArgs) Handles dataShowButton.Click

        Select Case dataShowButton.Content.ToString
            Case "過去のデータ一覧"
                ListBox1.Visibility = Xaml.Visibility.Visible
                Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
                Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("EarthQuakeData", CreationCollisionOption.OpenIfExists)
                Dim DataFile As IReadOnlyList(Of StorageFile) = Await mySubFolder.GetFilesAsync()
                Dim myFile As New List(Of String)

                For Each result In DataFile
                    myFile.Add(System.IO.Path.GetFileNameWithoutExtension(result.Path))
                    myFile2.Add(result.Path)
                Next
                ListBox1.ItemsSource = myFile
                dataShowButton.Content = "現在のデータ表示"
            Case "現在のデータ表示"
                ListBox1.Visibility = Xaml.Visibility.Collapsed
                dataShowButton.Content = "過去のデータ一覧"
                DataShow()
        End Select

    End Sub

    Private Async Sub ListBox1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        Try
            myMap.Children.Clear()
            Dim myStorageFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
            Dim mySubFolder = Await myStorageFolder.CreateFolderAsync("EarthQuakeData", CreationCollisionOption.OpenIfExists)
            Dim readXmlFile As IReadOnlyList(Of StorageFile) = Await mySubFolder.GetFilesAsync()
            Dim myText As String = Await FileIO.ReadTextAsync(readXmlFile(ListBox1.SelectedIndex))
            Dim doc As XElement = XElement.Parse(myText)

            myMap.MapType = MapType.Road

            Dim detectionDate As String = String.Empty
            Dim myLocation As String = String.Empty
            Dim myLatitude As String = String.Empty
            Dim myLongitude As String = String.Empty
            Dim myMagnitude As String = String.Empty
            Dim myIntensity As String = String.Empty

            Dim myDateTimeStr = ListBox1.SelectedItem.ToString
            Dim _year As String = myDateTimeStr.Substring(0, 4)
            Dim _month As String = myDateTimeStr.Substring(5, 2)
            Dim _day As String = myDateTimeStr.Substring(8, 2)
            Dim nenTukiHi As String = _year & "/" & _month & "/" & _day

            For Each result In From c In doc.Descendants("entry") Select c
                zIndexNo2 = zIndexNo2 + 1
                myLocation = result.Element("epicenter").Element("name").Value
                detectionDate = result.Element("detection_date").Value
                myLatitude = result.Element("epicenter").Element("coordinate").Element("latitude").Value
                myLongitude = result.Element("epicenter").Element("coordinate").Element("longitude").Value
                myMagnitude = result.Element("magnitude").Value
                myIntensity = result.Element("intensity_no").Value
                myMap.Center = New Location(CDbl(myLatitude), CDbl(myLongitude))
                Dim myEllipse As New Ellipse
                myEllipse.Width = 20
                myEllipse.Height = 20
                myEllipse.Stroke = New SolidColorBrush(Colors.Blue)

                Dim myStackPanel As New StackPanel
                myStackPanel.SetValue(Canvas.ZIndexProperty, zIndexNo2)
                'myStackPanel.Margin = New Thickness(10)
                myStackPanel.Background = New SolidColorBrush(Colors.Gainsboro)
                myStackPanel.Visibility = Xaml.Visibility.Collapsed
                Dim myTextBlock As New TextBlock
                myTextBlock.Padding = New Thickness(5)
                myTextBlock.Text = "発生日時=" & detectionDate & vbCrLf & "震源地=" & myLocation & vbCrLf & "マグニチュード=" & myMagnitude & vbCrLf & "震度=" & myIntensity
                myTextBlock.Foreground = New SolidColorBrush(Colors.Navy)
                myTextBlock.FontSize = 20
                myStackPanel.Children.Add(myTextBlock)

                MapLayer.SetPosition(myStackPanel, New Location(CDbl(myLatitude), CDbl(myLongitude)))
                myMap.Children.Add(myStackPanel)

                Dim _myDate As DateTime = Date.Now

                If detectionDate.Contains(nenTukiHi) = True Then
                    myEllipse.Fill = New SolidColorBrush(Colors.Red)
                Else
                    myEllipse.Fill = New SolidColorBrush(Colors.Yellow)
                End If

                MapLayer.SetPosition(myEllipse, New Location(CDbl(myLatitude), CDbl(myLongitude)))
                myMap.Children.Add(myEllipse)

                AddHandler myEllipse.Tapped, Sub()
                                                 myStackPanel.Visibility = Xaml.Visibility.Visible
                                             End Sub

                AddHandler myStackPanel.Tapped, Sub()
                                                    myStackPanel.Visibility = Xaml.Visibility.Collapsed
                                                End Sub
            Next
        Catch
            Exit Sub
        End Try
    End Sub
End Class
